/* 
  양액이 부족하면 트위터로 양액이 부족함을 알린다.
  "삼덕마을 환경영화 공작소"를 진행하며 호박이 넝쿨책에 수경재배기를 설치했다.
  수경재배기의 양액이 부족하면 트위터로 알려준다.
  
  2020.07.07
  박영기 
*/

#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>

char *ssid = "";
char *password = "";
int level_sensor = 15; // WeMos D8 
int led = 13; // built-in
int level;
int initial_level;

void setup()
{
  pinMode(level_sensor, INPUT);
  pinMode(led, OUTPUT);
  
  Serial.begin(115200);

  WiFi.mode(WIFI_STA);
  WiFi.disconnect();

  Serial.print("Connecting to \'");
  Serial.print(ssid);
  Serial.println("\'");

  WiFi.begin(ssid,password);

  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
  }
  Serial.println();
  Serial.println("WiFi connected.");

  initial_level = 1; // 1이면 초기값을 나타낸다.
}

void loop() 
{
  if (initial_level == 1)
  {
    level = 1;
  }
  else
  {
    level = digitalRead(level_sensor);
  }
  initial_level = 0;

  Serial.println(level);

  HTTPClient httpClient;

  String host = "http://api.thingspeak.com";
  String url = "/update?key=";
  String key = "6K71S6TRHD0KH3VH"; //ThingSpeak의 Write API Key
  String field1 = "&field1=";

  httpClient.begin(host + url + key + field1 + level);
  
  int httpCode = httpClient.GET();

  if (httpCode > 0)
  {
    Serial.printf("[HTTP] Nutrient Solution Level was logged...\n");
  }
  else
  {
    Serial.printf("[HTTP] Connection failed : %s\n", httpClient.errorToString(httpCode).c_str());
  }

  httpClient.end();

  if (level == LOW)
  {
    for (int i = 1; i <= 20; i++)
    {
      digitalWrite(led, !level); // level이 낮을 때 level의 값은 LOW이고, 그럴 때 LED가 켜진다.
      delay(500);
      digitalWrite(led, LOW);
      delay(500);
    }
  }
  else
  {
    delay(20000); //ThingSpeak이 data를 처리하는 데에 20초 정도가 걸린다.
  }
}
